=== debian/changelog ===
gmt (4.5.7-2) unstable; urgency=low

  * A link moved from gmt to gmt-doc, so conflicting current gmt-doc with
    old gmt.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Fri, 16 Mar 2012 14:14:25 +0100

gmt (4.5.7-1) unstable; urgency=low

  * New upstream version with a new compact distribution.
    (closes: #663099)
  * Policy bumped to 3.9.3, no changes required.
  * Now use in embedded mode quilt and all tar/unpack/patch target have been dropped.
  * Get-orig-source and all other special target dropped due to semplification
    of the distribution.
  * Added a build-dep on autotools-dev and provided usual snippets to override
    config.{sub,guess} files before configuring.
  * Moved to copyright format version 1.0. Note that in 4.5.6 GMT team added
    compatibility with any later version for GPL-2.
  * Splitted links helper in different files for each package to avoid 
    unresolved links.
  * This package requires GSHHS >= 2.2, as provided by a new separate package.
  * Fixed some symlinks.
    (closes: #343383)
  * Added a patch kfreebsd to allow working with GNU/kFreeBSD.
    (closes: #619960)
  * Fixed bashism in psbbox.sh with patch bashism.
    (closes: #581103)

 -- Francesco Paolo Lovergine <frankie@debian.org>  Tue, 13 Mar 2012 14:24:33 +0100
