## gmt 4.5.9

=== debian/changelog ===
gmt (4.5.9-1) unstable; urgency=low

  * Added Octave support and an ad-hoc new package for that.
  * Added octave-gmt package for supporting grid files in GNU octave.
  * Revised build-deps.
  * Debhelper level set to 9.
  * Lintian-based cleanups:
      - Fixed debian/changelog for a couple of silly warnings.
      - Added ${misc:Depends} to all pkgs.
  * Revised for Suggestions.
  * Fixed previous changelog for layout and contents.
  * ACK of previous NMUi by Sebastian Ramacher:
  	* debian/patches/eglibc-2.17.patch: Add missing include to fix FTBFS with
      eglibc 2.17. 
    (closes: #701431)
  * New upstream release. 
    (closes: #705022)
  * Patch kfreebsd refreshed to include hurd case instead.
    (closes: #676147)

 -- Francesco Paolo Lovergine <frankie@debian.org>  Fri, 16 Mar 2012 14:53:42 +0100
